TEMPLATE = app
CONFIG += release
DEPENDPATH += fontdata
INCLUDEPATH += .
chart {
   LIBS += -lchartdir
   DEFINES += CHART
}
TARGET = pdfreport

PLATFORM = $$[platform]

isEmpty(PLATFORM) {
  error("No platform configured: use qmake -set platform <foo>")
}

contains( PLATFORM, macx ) {
  message("Building for OS X...")
  COMPILER = gnu
  QMAKE_LFLAGS += -framework CoreFoundation
  RC_FILE = Icon.icns
}

contains( PLATFORM, linux ) {
  message("Building for Linux...")
  COMPILER = gnu
}

contains( PLATFORM, solaris ) {
  message("Building for Solaris...")
  COMPILER = sun
}

contains( PLATFORM, windows) {
  message("Building for Windows...")
  COMPILER = ms
}

# Input
HEADERS += afm.h \
           pdf.h \
           pdfCatalog.h \
           pdfchunk.h \
           pdfContent.h \
           pdfdocument.h \
           pdfFont.h \
           pdfImage.h \
           pdfPage.h \
           pdfPages.h \
           pdfXobject.h \
           pdfText.h \
           pdfGrid.h
SOURCES += main.cc \
           pdfCatalog.cc \
           pdfchunk.cc \
           pdfContent.cc \
           pdfdocument.cc \
           pdfFont.cc \
           pdfImage.cc \
           pdfPage.cc \
           pdfPages.cc \
           pdfXobject.cc \
           pdfText.cc \
           pdfGrid.cc
