// -*-C++-*-
// pdfFont.h
// $Id: pdfFont.h,v 1.1 2004/06/13 00:31:01 steve Exp steve $
//
// Copyright (C) 2001 Steve Atkins <steve@blighty.com>
// Last change: Time-stamp: <18-Jun-2004 11:43:18 steve>
//
//

#ifndef PDFFONT_H
#define PDFFONT_H

#include <qstring.h>



#include "pdfchunk.h"
#include <qstring.h>

class pdfFont : public pdfchunk
{
public:
  pdfFont(pdfdocument *doc, QCString basefont);
  virtual ~pdfFont();

  virtual const char * isA() const { return "pdfFont"; };

  virtual QByteArray render();
  
  double width(double pointsize, int glyph) const {return (pointsize * ((glyph>=0 && glyph<=255) ? p_width[glyph] : (p_boxr-p_boxl))) / 1000.0; };
  double ascender(double pointsize) const {return (pointsize * p_ascender) / 1000.0; };
  double descender(double pointsize) const {return (pointsize * p_descender) / 1000.0; };
  double kern(double pointsize, int left, int right) const;
  bool isKerned(int left, int right) const {return left>=0 && left <=255 && right >= 0 && right <= 255 && p_kern.contains((left << 8) | right); };
private:
  QCString p_basefont;
  
  int p_underlineposition;
  int p_underlinethickness;
  int p_capheight;
  int p_xheight;
  int p_ascender;
  int p_descender;
  int p_boxl;
  int p_boxr;
  int p_boxt;
  int p_boxb;
  int p_width[256];
  QMap<int,int> p_kern;
};


#endif // PDFFONT_H
