// -*-C++-*-
// pdfImage.cc
// $Id$
//
// Copyright (C) 2001 Steve Atkins <steve@blighty.com>
// Last change: Time-stamp: <11-Jul-2004 21:07:15 steve>
//
//

#include "pdfImage.h"
#include <qcolor.h>

pdfImage::pdfImage(pdfdocument *doc, const QImage& image) : pdfXobject(doc), p_image(image.convertDepth(32))
{
}

pdfImage::~pdfImage()
{
}

QByteArray pdfImage::render()
{
  //  cerr << "Entering pdfImage::render()\n";
  QByteArray im(3 * p_image.width() * p_image.height());
  {
    unsigned char *p = (unsigned char *)im.data();
    
    for(int row=0; row<p_image.height(); ++row) {
      QRgb *q = (QRgb*)p_image.scanLine(row);
      for(int col=0; col < p_image.width(); ++col) {
	QRgb c=*q++;
	*p++ = qRed(c);
	*p++ = qGreen(c);
	*p++ = qBlue(c);
      }
    }
  }

  QByteArray compimage(im.size() * 3);

  int streamlen = makestream(im, compimage, 0, 0);
  QByteArray ret(streamlen + 300);
  char *p = ret.data();
  p+=sprintf(p, "<< /Subtype /Image\n"
	     "/Width %d\n"
	     "/Height %d\n"
	     "/ColorSpace /DeviceRGB\n"
	     "/BitsPerComponent 8\n"
	     "/Filter /ASCIIHexDecode\n"
	     "/Length %d\n"
	     ">>\n"
	     "stream\n",
	     p_image.width(),
	     p_image.height(),
	     streamlen);

  qmemmove(p, compimage.data(), streamlen);
  p += streamlen;
  p+=sprintf(p, "\nendstream\n");
  ret.resize(p-ret.data());
  return ret;
}
