// -*-C++-*-
// pdfPage.h
// $Id: pdfPage.h,v 1.1 2004/06/13 00:26:57 steve Exp steve $
//
// Copyright (C) 2001 Steve Atkins <steve@blighty.com>
// Last change: Time-stamp: <13-Jul-2004 16:33:10 steve>
//
//

#ifndef PDFPAGE_H
#define PDFPAGE_H

#include "pdfchunk.h"
#include <qvaluelist.h>
#include <qstring.h>
#include "pdfdocument.h"
#include <qimage.h>
class pdfPages;
class pdfContent;
class pdfXobject;

class pdfPage : public pdfchunk
{
public:
  pdfPage(pdfdocument *doc, double width=612.0, double height=792.0);
  virtual ~pdfPage();

  virtual const char * isA() const { return "pdfPage"; };
  virtual QByteArray render();
  void setParent(pdfPages *newparent) { p_parent=newparent; };
  pdfPages *parent() const {return p_parent; };
  void useFont(QCString tag, QCString basefont) { fontmap[tag] = basefont; fonttag[basefont] = tag; document()->useFont(basefont); };
  QCString fontTag(QCString basefont);
  void includeContent(pdfContent *c) { content.append(c); };
  void includeXobject(QCString name, pdfXobject *c) { xobject[name] = c; };
  void includeXobject(QCString name) { xobject[name] = document()->getXobject(name);};
  pdfContent *newContent();

  bool xobjectExists(QCString name) const { return xobject.contains(name);};
  void insertImage(const QCString name, const QImage& image);
  double height() const { return p_height; };
  double width() const { return p_width; };
  pdfContent *baseContent() const { return content.front();};
private:
  pdfPages *p_parent;
  pdfchunk *p_thumbnail;
  QMap<QCString,QCString> fontmap;
  QMap<QCString,QCString> fonttag;
  double p_height;
  double p_width;
  QValueList<pdfContent*> content;
  QMap<QCString,pdfXobject*> xobject;
  int fontspin;
};


#endif // PDFPAGE_H
