// -*-C++-*-
// pdfPages.cc
// $Id: pdfPages.cc,v 1.1 2004/06/13 00:26:57 steve Exp steve $
//
// Copyright (C) 2001 Steve Atkins <steve@blighty.com>
// Last change: Time-stamp: <11-Jul-2004 22:40:35 steve>
//
//

#include "pdfPages.h"
#include "pdfPage.h"

pdfPages::pdfPages(pdfdocument *doc) : pdfchunk(doc), parent(0)
{
}

pdfPages::~pdfPages()
{
}

int pdfPages::countPages()
{
  int count = pages.count();
  for(QValueList<pdfPages*>::const_iterator cit=subnodes.begin(); cit!=subnodes.end(); ++cit) {
    count += (*cit)->countPages();
  }
  return count;
}

void pdfPages::insertPage(pdfPage *p)
{
  p->setParent(this);
  pages.append(p);
}

QByteArray pdfPages::render()
{
  //  cerr << "Entering pdfPages::render()\n";
  int nodes = subnodes.count() + pages.count();
  QByteArray ret(11 * nodes + 100);
  char *p = ret.data();
  p+=sprintf(p, "<< /Type /Pages\n");
  if(parent) {
    p+=sprintf(p, "/Parent %d 0 R\n", parent->index());
  }
  p+=sprintf(p, "/Kids [ ");
  for(QValueList<pdfPages*>::const_iterator cit=subnodes.begin(); cit!=subnodes.end(); ++cit) {
    p+=sprintf(p, "%d 0 R\n", (*cit)->index());
  }
  for(QValueList<pdfPage*>::const_iterator cit=pages.begin(); cit!=pages.end(); ++cit) {
    p+=sprintf(p, "%d 0 R\n", (*cit)->index());
  }
  p+=sprintf(p, "]\n/Count %d\n>>\n", countPages());
  ret.resize(p-ret.data());
  return ret;
}
