// -*-C++-*-
// pdfchunk.cc
// $Id: pdfchunk.cc,v 1.1 2004/06/13 00:26:57 steve Exp steve $
//
// Copyright (C) 2001 Steve Atkins <steve@blighty.com>
// Last change: Time-stamp: <11-Jul-2004 21:05:50 steve>
//
//

#include "pdfchunk.h"
#include "pdfdocument.h"

using namespace std;

pdfchunk::pdfchunk()
{
}

pdfchunk::pdfchunk(pdfdocument *doc) : idx(-1), p_document(doc)
{
  doc->append(this);
}

pdfchunk::~pdfchunk()
{
}

int pdfchunk::makestream(const QByteArray& in, const QByteArray& out, int offset, int type)
{
  //  cerr << "makestream, in.size=" << in.size() << "\n";
  // Hex encode for now
  const unsigned char *q=(const unsigned char*)in.data();
  const unsigned char *qend=q+in.size();
  char *p = out.data() + offset;
  int linespin = 30;
  while(q < qend) {
    sprintf(p, "%02x", (int)(*q));
    p+=2;
    if(linespin-- == 0) {
      linespin = 30;
      *p++ = '\n';
    }
    ++q;
  }
  *p++ = '>';
  *p++ = '\n';
  //  cerr << "returning " << offset + (p-out.data()) << "\n";
  return offset + (p-out.data());
}
